# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

.macro apm_power_off ver,seg=%ds
  push \seg
  push \ver
  push $0x4
  call pnp_bios_
  add $6,%sp
.endm

  call com_init_mem
 call pnp_bios_init
  exit_if_cf $1,"cant find pnp"
  do_fd $1,"entry point=",hex,16,pnp_bios_entry_point+2,$':'
  fdhex $1,16,pnp_bios_entry_point,$'\n'
  puts "checking for bios boot spec"
  bbs_install_check $bbs_ver
  if_rz %ax,0f
  exit_msg $1,"no bios boot spec installed"
0:
  do_fd $1,"bios boot spec  found ver=",hex,16,bbs_ver,$'\n'

  bbs_get_ipl_dev_count pnp_bios_entry_point,$num_ipl_devs,$ipl_max_devs,$ipl_entry_sz
  if_rz %ax,0f
  exit_msg $1,"cant get IPL dev list"
0:

  do_fd $1,"max ipl devs=",hex,16,ipl_max_devs,$'\n'
  do_fd $1,"table entry sz=",hex,16,ipl_entry_sz,$'\n'

  bbs_get_boot_first pnp_bios_entry_point,$boot_first
  if_rz %ax,0f
  exit_msg $1,"failed getting boot first dev"
0:
  do_fd $1,"boot first ix=",hex,16,boot_first,$'\n'
  terminate 00

.bss
bbs_ver: .word 0
num_ipl_devs: .word 0
ipl_max_devs: .word 0
ipl_entry_sz: .word 0
boot_first: .word 0

.if 0
  bbs_get_prty_tbl pnp_bios_entry_point,$0,$priority,$table
  if_rz %ax,0f
  exit_msg $1,"no ipl table or  priority"
0:
priority: .space 4096
table: .space 4096
.endif
