# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "comint.h"

   init_args
   arg_value d,"baud divisor"
   call stowd
  mov %al,divisor
   ret
.data
divisor: .byte 12
  arg_item v,verbose,"be verbose"
   arg_value o,"output file"
  lea ofn,%di
  call strcpy_
  ret
.data
ofn: .space 0x80
   init_args_term
  push $0
  call port2uart
  mov %ax,port_uart

   xcreate_file $ofn,$0
  mov %ax,handle

  if_z verbose,0f,b
  fdprint handle,"log opened ok\n"
0:

  serial_config port_uart,divisor

  push $1
   push %cs
  push $int8_handler
  push port_uart
  call enable_com1_hdlr

  lea filebuf,%di
0: bios_check_keystroke
  jnz 1f
  serial_status port_uart
  xchg %al,%ah
  if_unset $2,%al,no_overrun
  dos_playnote_ms $55,$3000
  jmp 1f
no_overrun:
   if_z q_count,0b,w
     mov com1_q_read,%si
    lodsb
   if %si,b,$com1_q_end,2f
   movw $com1_q,%si
2: mov %si,com1_q_read
   decw q_count
  stosb
  if %di,b,$filebuf_end,0b
 call flush_buf
  lea filebuf,%di
  jmp 0b
1:

  call flush_buf
   serial_config port_uart,$12
   push port_uart
  call disable_com1_hdlr

  if_z verbose,0f,b
   fdprint handle,"closing file\n"
0:
  mov handle,%bx
  dos_close_file
  terminate 00

flush_buf:
  xpushregs %ax,%bx,%cx,%dx
  mov filebuf,%ax
  lea filebuf,%dx
   mov %di,%cx
   sub %dx,%cx
  mov handle,%bx
  dos_write_handle
  xpopregs %dx,%cx,%bx,%ax
  ret
int8_handler:
   pusha
  xpushregs %ds,%es
  pushf
  movseg %cs,%ds
  movseg %cs,%es
 playnote_ms $440,$500
   mov $0x3f8,%dx
    in (%dx),%al
    incw q_count
     mov com1_q_write,%di
   stosb
  if %di,b,$com1_q_end,0f
   mov $com1_q,%di
0:
  mov %di,com1_q_write
  mov $0x64,%al
  out %al,$0x20
  popf
  xpopregs %es,%ds
  popa
  iret
.data
old_int8: .long 0
com1_q_read: .word com1_q
com1_q_write: .word com1_q
q_count: .word 0
.bss
port_uart: .word 0
handle: .word 0
com1_q: .space 16
com1_q_end:
filebuf: .space 2
filebuf_end:
