# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "comint.h"

   init_args
  arg_item n,no_config,"no serial config"
  arg_value t,"time out"
   call strtoul_
  movzwl %ax,%eax
  imul $182,%eax,%eax
   zeroreg %edx
  mov $0xa,%ecx
   div %ecx
  mov %eax,time_out
  ret
  .data
time_out: .long 18
   arg_value d,"baud divisor"
   call strtoul_
  mov %al,divisor
   ret
.data
divisor: .byte 12
  arg_item v,verbose,"be verbose"
   init_args_term
  push $0
  call port2uart
  mov %ax,uart

  if_nz no_config,0f,b
  serial_config uart,divisor
0:

    playnote_ms $440,$500

  push $1
   push %cs
  push $intc_handler
  push uart
  call enable_com1_hdlr

0: bios_check_keystroke
  jz 1f
  call getchx
  if %al,e,$0x1b,exit_prog
  call running_status
  jmp 0b
1:   call check_state
  jmp 0b
exit_prog:
  if_nz no_config,0f,b
   serial_config uart,$12
0:   push uart
  call disable_com1_hdlr

  playnote_n $440,$500
  terminate 00

intc_handler:
   pushal
  xpushregs %ds
  movseg %cs,%ds
  call get_system_time
  mov %eax,last_arrived
  if_nz total_bytes,0f,l
   mov %eax,total_start_time
0:   if_nz num_bytes,0f,l
   mov %eax,start_time
0:   mov uart,%dx
    in (%dx),%al
  mov $0x64,%al
  out %al,$0x20
  incl total_bytes
  incl num_bytes
  xpopregs %ds
  popal
  iret
check_state:
 pushal
  if_z num_bytes,999f,l
   call get_system_time
   if last_arrived,a,%eax,999f
   sub last_arrived,%eax
  if %eax,b,time_out,999f
  mov last_arrived,%eax
  sub start_time,%eax
  do_fd $1,"ticks=",i2asc,l,%eax,$'\n'
  imul $0xa,%eax,%eax
  zeroreg %edx
  mov $182,%ecx
   div %ecx
  do_fd $1,"secs=",i2asc,l,%eax,$'\n'
   if_rnz %eax,0f
    mov $1,%eax
0:  mov %eax,%ecx
   zeroreg %edx
  mov num_bytes,%eax
  div %ecx
  xchg %eax,%edx
   do_fd  $1,"nb=",i2asc,l,num_bytes,$'\n'
     do_fd $1,"bps=",i2asc,l,%edx,$'\n'
 playnote_ms $440,$50
  movl $0,num_bytes
999:  popal
 ret
running_status:
  pushal
   do_fd $1,"total bytes=",i2asc,l,total_bytes,$'\n'
   mov last_arrived,%eax
    sub total_start_time,%eax
  imul $0xa,%eax,%eax
  zeroreg %edx
  mov $182,%ecx
  div %ecx
   mov %eax,%ecx
  if_rnz %ecx,0f
  mov $1,%ecx
0:   zeroreg %edx
   mov total_bytes,%eax
   div %ecx
   do_fd $1,"bps=",i2asc,l,%eax,$'\n'
  popal
  ret
.data
total_bytes: .long 0
num_bytes: .long 0
.bss
total_start_time: .long 0
start_time: .long 0
last_arrived: .long 0
uart: .word 0
