# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

  init_args
  arg_item n,no_config,"no serial config"
  arg_value p,"pause len"
  call strtoul_
  mov %eax,pause_len
  ret
.data
pause_len: .long 18
  arg_value d,"baud divisor"
  call strtoul_
  mov %al,divisor
   ret
.data
divisor: .byte 12
   init_args_term

   port2uart $0
  mov %ax,uart
   if_nz no_config,0f,b
   serial_config  uart,divisor
0:   bios_check_keystroke
   jnz exit_prog
  call pause_for_breath
    mov uart,%dx
   add $_d_lsr,%dx
   in (%dx),%al
   if_unset $1,%al,0b
   mov uart,%dx
  in (%dx),%al
  call process_byte
  jmp 0b

exit_prog:
if_nz no_config,0f,b
serial_config uart,$12
0:  playnote_ms $440,$500
  terminate 00
process_byte:
   call get_system_time
   if_nz num_bytes,0f,l
     mov %eax,start_time
0:   mov %eax,last_arrived
  incl num_bytes
  ret
pause_for_breath:
  if_z num_bytes,999f,l
    call get_system_time
    sub last_arrived,%eax
 if %eax,be,pause_len,999f
   do_fd $1,"bytes=",i2asc,l,num_bytes,$'\n'
   mov last_arrived,%eax
  sub start_time,%eax
  do_fd $1,"ticks=",i2asc,l,%eax,$'\n'
    imul $0xa,%eax,%eax
   zeroreg %edx
   mov $182,%ecx
   div %ecx
  mov %eax,%ecx
  if_rnz %ecx,1f
   mov $1,%ecx
1:
  zeroreg %edx
   mov num_bytes,%eax
  div %ecx
  do_fd $1,"bps=",i2asc,l,%eax,$'\n'
  playnote_ms $440,$500
  movl $0,num_bytes
999:
  ret
.data
num_bytes: .long 0
.bss
uart: .word 0
start_time: .long 0
last_arrived: .long 0
