# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

read_chunk_secs=0x3f
read_chunk_buf=0x6000

  jmp start_code
src_disc: .byte 0x81
src_part: .byte 1
dest_disc: .byte 0x81
dest_part: .byte 2
start_code:
  cli
   set_segs %cs
  lea 0xfffe,%sp
  sti
  mov src_disc,%al
  if %al,ne,$0xff,0f
  mov %dl,src_disc
0: mov src_disc,%dl
  call check_lba
  mov dest_disc,%dl
  call check_lba
# read mbr  for src and dsst and get start/len
  mov src_disc,%ax
  call read_mbr
  mov %eax,src_start
  mov %edx,src_len

  mov dest_disc,%ax
   call read_mbr
  mov %eax,dest_start
  mov %edx,dest_len

  mov $read_chunk_buf,%di
  zeroreg %bx
start_read_loop:   mov $read_chunk_secs,%eax
  if %eax,be,src_len,0f
     mov src_len,%eax
0:  if %eax,b,dest_len,0f
  mov dest_len,%eax
0:  mov src_disc,%dl
   mov src_start,%ecx
  mov $_d_lba_read_fn,%ah
  call lba_io
  if_rz %ax,exit_prog
#  write_lba
  mov dest_disc,%dl
  mov dest_start,%ecx
   mov $_d_lba_write_fn,%ah
  call lba_io
  if_rz %eax,exit_prog
  if %eax,ae,src_len,exit_prog
  if %eax,ae,dest_len,exit_prog
  sub %eax,src_len
  add %eax,src_start
  sub %eax,dest_len
  add %eax,dest_start
  jmp start_read_loop
exit_prog:    playnote_bios_ $1760,$1000
  reboot
barf: playnote_bios_ $55,$1000
  reboot
# on entry ax is disc/part
# reads the mbr and returns the start/len for teh mbr on that disc
read_mbr: _enter $512
  if_rz %ah,0f
   if %ah,ae,$4,0f
  jmp 1f
0: zeroreg %eax
  mov $10*read_chunk_secs,%edx
  jmp 999f
1:  mov %ax,%dx
  mov %ds,%di
  mov %sp,%bx
0:  mov $1,%al
  zeroreg %ecx
  mov $_d_lba_read_fn,%ah
  call  lba_io
  add $0x1be,%bx
  dec %dh
  shl $0x4,%dh
  movzbw %dh,%dx
  add %dx,%bx
  mov 0x8(%bx),%eax
  mov 0xc(%bx),%edx
999:  leave
  ret

# on entry di:bx is the buffer addr
# al is the num of sectors
# ah is the fn
# dl is the drive
# ecx is the  start sector
lba_io:
  xpushregs %bx,%dx
  pushl $0
  push %ecx
  push %di
  push %bx
  movzbw %al,%bx
  push %bx
  push $0x10
  mov  %sp,%si
  int $0x13
  jc barf
   mov 2(%si),%ax
  movzwl %ax,%eax
  add $0x10,%sp
  xpopregs %dx,%bx
  ret

check_lba:
  ibm_ext_check
  jc barf
  ret
src_start: .long 0
src_len: .long -1 
dest_start: .long 0
dest_len: .long -1
