# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

.macro dmi_print_string str,n,struct
  push \struct
  push \n
  push $str\@
  call dmi_print_string
.data
str\@: .asciz "\str="
.previous
.endm

  call com_init_mem

 call pnp_find_entry
  exit_if_cf $1,"cant find pnp"
  mov %eax,entry_point
  pnp_get_system_nodes entry_point,$num_nodes,$node_sz
  dmi_get_info entry_point,$rev,$num,$sz,$st_addr,$st_sz

0:
  dmi_get_struc entry_point,$dmi_handle,$dmi_struc
   if_rnz %ax,exit_prog
   if dmi_handle,e,$0xffff,exit_prog
  movzbw dmi_struc+1,%di
     hexdump $1,%ds,$dmi_struc,%di
  push $dmi_struc
  push dmi_handle
 call dmi_print
  jmp 0b

exit_prog:
  terminate 00    
    
parm_start
parm_sym handle int_t 0
parm_sym struct int_t 0
parm_end
dmi_print: _enter
  pusha
  mov handle(_bp),%dx
  fdhex $1,16,%edx,$' '
  mov struct(_bp),%bx
  mov (%bx),%dx
  do_fd $1,"type=",hex,8,%edx,$'\n'
  movzbw %dh,%di
  add %bx,%di
  if_rnz %dl,50f
   dmi_print_string "vendor",4(%bx),%di
   dmi_print_string "version",5(%bx),%di
  do_fd $1,"runtime bios seg=",hex,16,6(%bx),$'\n'
   dmi_print_string "bios release date",6(%bx),%di
  movzbl 9(%bx),%eax
  inc %eax
  do_fd $1,"bios rom size(64k blocks)=",hex,8,%eax,$'\n'
  jmp 999f
50:
  if %dl,a,$4,51f
   dmi_print_string "manufacturer",4(%bx),%di
  if %dl,a,$3,50f
   dmi_print_string "product",5(%bx),%di
   dmi_print_string "version",6(%bx),%di
   dmi_print_string "serial",7(%bx),%di
  jmp 999f
50:
  do_fd $1,"chassis type=",hex,8,5(%bx),$'\n'
   dmi_print_string "version",6(%bx),%di
   dmi_print_string "serial",7(%bx),%di
   dmi_print_string "asset tn",8(%bx),%di
  do_fd $1,"last boot stat flags=",hex,32,9(%bx),$'\n'
  jmp 999f
51:
   dmi_print_string "str(1)",$1,%di
999: popa
  leave
  ret $ret_sz
parm_start
parm_sym str int_t 0
parm_sym n int_t 0
parm_sym struct int_t 0
parm_end
dmi_print_string: _enter
  pusha
   mov str(_bp),%si
  call dos_print
  movzbw n(%bp),%dx
  _string_n struct(_bp),%dx
    mov %ax,%si
  call dos_puts
 popa
  leave
  ret $ret_sz

.data
dmi_handle: .word 0
.bss
entry_point: .long 0
num_nodes: .byte 0
node_sz: .word 0
num:.word 0
sz: .word 0
st_addr: .long 0
st_sz: .word 0
rev:  .space 80
dmi_struc: .space 0x8000 # dunno how to find the max this can be
