# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

.macro fdparms s,l,v
  print "\s "
  fdhex $1,\l,%fs:\v,$'\n'
.endm

.macro parm_print s,l
  print "\s="
    fdhex $1,\l,drive_parms+gdp_\s,$'\n'
.endm

.struct 0
int13_drive_parms gdp_
gdp_dp_sz=.-gdp_drive_parms
pop_sect

 call pinit
    if_z%ax,0f
   mov argv,%si
  call strtoul_
    mov %al,drive_parms+gdp_drive
0:
  pushw $drive_parms
  call get_drive_parms
  jnc 0f
  print "cant get parms for drive "
   mov drive_parms+gdp_drive,%dx
  call hexoutword
    print "  errorcode="
    fdhex $1,8,%eax,$'\n'
  terminate 00
0:  parm_print drive,8
parm_print drive_type,8
parm_print cyls,16
 parm_print heads,8
 parm_print secs,8
 parm_print drives,8
 if_z  gdp_drive_type,0f,b
    call print_floppy_parms
0:
  terminate 00 

print_floppy_parms:
  xpushregs %ax,%dx,%si,%fs
  print "fd parm table is at "
   fdhex $1,16,drive_parms+gdp_parm_table+2,$':'
   fdhex $1,16,drive_parms+gdp_parm_table,$'\n'
  mov drive_parms+gdp_parm_table,%si
  movseg drive_parms+gdp_parm_table+2,%fs
    fdparms "first specify byte",8,(%si)
    fdparms "second specify byte",8,1(%si)
    fdparms "delay before motor turns off",8,2(%si)
    fdparms "sector size",8,3(%si)
    fdparms "sectors per track",8,4(%si)
    fdparms "inter sector gap",8,5(%si)
    fdparms "gap length",8,7(%si)
   xpopregs %si,%fs,%dx,%si
  ret
.data
drive_parms: .space gdp_dp_sz
