# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "dt_tsr.h"

  init_args
  arg_value x,"terminate if esc pressed in n ms"
  call strtoul_
  mov %ax,wait_for_esc
 ret
.data
wait_for_esc: .long 0
  arg_value o,"output file"
  lea tsr_fn,%di
  call strcpy_
  ret
  arg_item P,dont_set_port,"dont initialise port"
  arg_item f,force_load,"force load any way"
  arg_item q,quiet,"quiet"
  arg_item n,no_dbltalk_codes,"no double talk codes"
   init_args_term

  mov wait_for_esc,%eax
  if_rz %eax,0f
  playnote_ms $1760,$500
  playnote_ms $1760,$500
  playnote_ms $880,$500
   waitkey_ms $0x1b,%eax
   jc 0f
  playnote_ms $55,$500
 terminate 00
0:
vector dos_getvector
  mov  %bx,jaddr
  mov %es,jaddr+2
  if %es:sig-tsr_start(%bx),ne,$tsr_sig,init_ok,w
  exit_msg $1,"tsr already there"
init_ok:
  lea tsr_fn,%si
  call open_output_dev
  mov %ax,tsr_handle
  if_nz dont_set_port,0f,b
 call is_com_dev
  jz 0f
  serial_config  tsr_handle,$0xc
0: 
 if no_dbltalk_codes,ae,$2,0f,b
  call is_com_dev
  jz 0f
  serial_write tsr_handle,$cmd0,$cmd0_l
  serial_write tsr_handle,$cmd1,$cmd1_l
0:
 mov $tsr_start,%dx
  vector  dos_setvector
   get_vector $0x15
  mov %eax,jaddr15
   set_vector $0x15,%cs,$tsr15_start
  if_nz quiet,0f,b
  lea comp_date_msg,%si
  call dos_puts
  info_print "vector set to -> ",%ds,%dx
   if_nz no_dbltalk_codes,0f,b
   puts "doubletalk mode"
0:
  mov %cs:0x2c,%es
   dos_free
  dos_terminate_stay_resident $0,$image_end

cmd0: .ascii "\x01@\r"
cmd0_l=.-cmd0
cmd1: .byte 1,'1','Y','\r'
cmd1_l=.-cmd1

tsr_start:  
  int21_call tsr_sig,jmp_opcode
  pushf
  if %ah,e,$0x4c,dos_terminate
  if %ah,ne,$0x9,not_dollar_str
  pusha
  mov %sp,%bp
  mov $1,%bx
  call dt_tsr_isatty
   jne 999f
 mov %dx,%si
0:
   lodsb
  if %al,e,$'$',1f
  call write_single_char
  jmp 0b
  call do_sync
1:
  call do_pause
999:
  popa
  jmp int21jmp_exit
not_dollar_str:
  if %ah,e,$2,1f
  if %ah,e,$6,1f
  jmp not_write_char
1:  pusha
  mov $1,%bx
  call dt_tsr_isatty
   jne 999f
  mov %dl,%al
  call write_single_char
999: popa
  jmp int21jmp_exit
not_write_char:
  if %ah,ne,$0x40,int21jmp_exit 
  if %bx,e,$1,okfor_dt
  if %bx,e,$2,okfor_dt
  jmp int21jmp_exit 
okfor_dt:
  call dt_tsr_isatty
  jne int21jmp_exit
  pushregs ax,bx,cx,dx,si,bp,ds
   mov %sp,%bp
  movseg %cs,%ds
  if_nz no_dbltalk_codes,past_setvoice,b
  movb $stdout_voice,setvoice+1
  if %bl,e,$_d_stdout_fileno,0f
  movb $stderr_voice,setvoice+1
0:
  lea setvoice,%si
   dt_puts
past_setvoice:
  mov l_ds(%bp),%ds
   mov l_dx(%bp),%dx
   call dt_write
  call do_sync
999:
  _popregs ds,bp,si,dx,cx,bx,ax
  mov %cx,%ax
   jmp do_iret_exit
tsr15_start:
  if %ah,ne,$0x4f,int15jmp
  pushf
  pusha
  xpushregs %ds,%fs
  if %al,e,$0x9d,50f
  if %al,ne,$0x81,int15_exit
  movseg $0x40,%fs
   mov  %fs:0x17,%dl
    if_unset $3,%dl,int15_exit
  mov %cs:shut_up,%al
   not %al
  call play_note
    mov %al,%cs:shut_up
  if_z %al,int15_exit
50: 
   call is_com_dev
    jz int15_exit 
# i think this should work as long as the data seg and stack seg are in teh same place!
  mov %ss,%ax
  mov %ax,%ds
 serial_putc $_d_dt_flush_buffer_char,%cs:tsr_handle
  movb $1,%cs:kbd_int_occured
int15_exit: xpopregs %fs,%ds
  popa
 popf
  jmp int15jmp
dt_write:
  pusha
  if_nz %cs:shut_up,999f,b
  movb $0,%cs:kbd_int_occured
    call is_com_dev
  jz 50f
  xpushregs %ds,%fs
  cld
  movseg %ds,%fs
  movseg %ss,%ds
  mov %dx,%si
100: lodsb %fs:(%si),%al
   serial_putc %ax,%cs:tsr_handle
  if_nz %cs:kbd_int_occured,102f,b
  loop 100b
102: movb $0,%cs:kbd_int_occured
  xpopregs %fs,%ds
  jmp 999f
50:  call tsr_write
999:
 popa
  ret

dos_terminate:
# doesn't matter if we knacker a few regs as its goign to die anyway
  xor %dx,%dx
  mov %dx,%es
   mov %al,%es:rc_addr
    dos_int21
# thats it never coems back
dt_tsr_isatty: 
  pusha
 call  tsr_dev_info
   and $0x83,%al
   cmp $0x83,%al
  popa
  ret

write_single_char:
 pusha
  if_nz %cs:shut_up,999f,b
   call tsr_write_char
  if %al,e,$'\r',101f
  if_nz %al,999f
101:
  call do_pause 
999:  popa
  ret
do_pause:
  if_nz no_dbltalk_codes,0f,b
  dos_usleep $500
0:
  ret
tsr_write_char: 
 pusha
  push %ds
  pushf
     movseg %cs,%ds
   call is_com_dev
  je 0f
  serial_putc %ax,tsr_handle
  jmp 999f
0:  mov %al,char_to_write
   mov tsr_handle,%bx
     call tsr_dev_info
    if %ax,e,$0x80c0,0f
   if char_to_write,e,$'\r',999f
0: mov $1,%cx
    lea char_to_write,%dx
  call tsr_write
999:
  popf
  pop %ds
 popa
  ret
tsr_write: 
 pusha
  dos_get_current_psp
 push %bx
    dos_set_psp %cs # since started off as a .com
 mov %cs:tsr_handle,%bx
  mov $0x40,%ah
   dos_int21
   mov %cs:save_psp,%bx
  pop %bx
  dos_set_psp
 popa
  ret
do_sync:
 pusha
  pushf
  call is_com_dev
   jz 50f
 push %ds
  movseg %ss,%ds
   serial_putc $'\r',%cs:tsr_handle
  pop %ds
  jmp 999f
50:  dos_get_current_psp
  push %bx
    dos_set_psp %cs
  dos_flush %cs:tsr_handle
  pop %bx
  dos_set_psp
999:  popf
 popa
  ret
do_iret_exit:
  popf
  clc
  iret
play_note: 
   pusha
  pushl $500
   if_nz %al,0f
   pushl $1760
  jmp 1f
0: pushl $220
1:  call playnote_ms
 popa
   ret 
tsr_dev_info:
  mov $0x4400,%ax
  dos_int21
  ret
int21jmp_exit:
   popf
  jmp int21jmp
open_output_dev:
  mov (%si),%ax
  if %al,ne,$'@',50f
  movzbw %ah,%ax
  and $0xf,%ax
  port2uart %ax
    jmp 999f
50:  push $0
  push %si
  call  xcreate_file
999: ret
is_com_dev:
  testb  $-1,%cs:tsr_handle+1
  ret
char_to_write: .byte 0
gsym shut_up .byte 0
save_psp: .word 0
gsym tsr_handle .word 3
tsr_fn: .asciz "@0"
.=tsr_fn+0x80
setvoice: .byte 1,0,'o',1,'1','y',1,'1','b',0
kbd_int_occured: .byte 0
