# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "dt_tsr.h"

  init_args
  arg_value x,"terminate if esc pressed in n ms"
  call strtoul_
  mov %ax,wait_for_esc
 ret
.data
wait_for_esc: .long 0
  arg_value o,"output file"
  lea tsr_fn,%di
  call strcpy_
  ret
  arg_item P,dont_set_port,"dont initialise port"
  arg_item f,force_load,"force load any way"
  arg_item q,quiet,"quiet"
  arg_item n,no_dbltalk_codes,"no double talk codes"
   init_args_term

  mov wait_for_esc,%eax
  if_rz %eax,0f
  playnote_ms $1760,$500
  playnote_ms $1760,$500
  playnote_ms $880,$500
   waitkey_ms $0x1b,%eax
   jc 0f
  playnote_ms $55,$500
 terminate 00
0:vector dos_getvector
  mov %bx,jaddr
   mov %es,jaddr+2
  if %es:sig-tsr_start(%bx),ne,$tsr_sig,init_ok,w
  exit_msg $1,"tsr already there"
init_ok:
  xcreate_file $tsr_fn,$0
  mov %ax,tsr_handle
  if_nz dont_set_port,dt_ok,b
  dt_set_port # use bios to always set com1 to 9600,8,n,1
  mov $0xe3,%al
  init_serial_port
   if_nz %al,dt_ok
  if_nz force_load,dt_ok,b
  playnote_ $55,$10
   terminate 00
dt_ok:  
  if no_dbltalk_codes,ae,$2,0f,b
   isatty tsr_handle
   jnz 0b
  dos_write tsr_handle,%ds,$cmd0,$cmd0_l
  dos_write tsr_handle,%ds,$cmd1,$cmd1_l
0:
 mov $tsr_start,%dx
  vector  dos_setvector
   get_vector $0x15
  mov %eax,jaddr15
   set_vector $0x15,%cs,$tsr15_start
  if_nz quiet,0f,b
  lea comp_date_msg,%si
  call dos_puts
  info_print "vector set to -> ",%ds,%dx
   if_nz no_dbltalk_codes,0f,b
   puts "doubletalk mode"
0:
  mov %cs:0x2c,%es
   dos_free
  dos_terminate_stay_resident $0,$image_end
dt_present:
  pushregs ax,dx
  zeroreg %al
  call tsr_write_char
  call read_port
  call read_port
  call read_port
   _popregs  dx,ax
  ret

read_port:
  xor %al,%al
  dt_set_port
100:  read_serial_port
  test $0x80,%ah
  jnz 100b
  or %al,%al
  jnz 999f
  mov $60,%ax
  mov $19,%cx
  call playnote_
  terminate 01
999:
  ret

cmd0: .asciz "\x01@"
cmd0_l=.-cmd0
cmd1: .byte 1,'1','y'
cmd1_l=.-cmd1

tsr_start:  
  int21_call tsr_sig,jmp_opcode
  pushf
  if %ah,e,$0x4c,dos_terminate
  if %ah,ne,$0x9,not_dollar_str
  pusha
  mov %sp,%bp
  mov $1,%bx
  call dt_tsr_isatty
   jne 999f
 mov %dx,%si
0:
   lodsb
  if %al,e,$'$',1f
  call write_single_char
  jmp 0b
  call do_flush
1:
  call do_pause
999:
  popa
  jmp int21jmp_exit
not_dollar_str:
  if %ah,e,$2,1f
  if %ah,e,$6,1f
  jmp not_write_char
1:  pusha
  mov $1,%bx
  call dt_tsr_isatty
   jne 999f
  mov %dl,%al
  call write_single_char
  call do_flush
999: popa
  jmp int21jmp_exit
not_write_char:
  if %ah,ne,$0x40,int21jmp_exit 
  if %bx,e,$1,okfor_dt
  if %bx,e,$2,okfor_dt
  jmp int21jmp_exit 
okfor_dt:
  call dt_tsr_isatty
  jne int21jmp_exit
  pushregs ax,bx,cx,dx,si,bp,ds
   mov %sp,%bp
  movseg %cs,%ds
  if_nz no_dbltalk_codes,past_setvoice,b
  movb $stdout_voice,setvoice+1
  if %bl,e,$_d_stdout_fileno,0f
  movb $stderr_voice,setvoice+1
0:
  lea setvoice,%si
   dt_puts
past_setvoice:
  mov l_ds(%bp),%ds
   mov l_dx(%bp),%si
   call dt_write
  call do_flush
999:
  _popregs ds,bp,si,dx,cx,bx,ax
  mov %cx,%ax
   jmp do_iret_exit
tsr15_start:
  if %ah,ne,$0x4f,int15jmp
  if %al,ne,$0x81,int15jmp
  pusha
  pushf
  push %fs
  movseg $0x40,%fs
   mov  %fs:0x17,%dl
    if_unset $4,%dl,100f
  mov %cs:shut_up,%al
   not %al
  call play_note
    mov %al,%cs:shut_up
  if_z %al,100f
   if_nz no_dbltalk_codes,100f,b
  mov $_d_dt_flush_buffer_char,%al
 call tsr_write_char
100:
  pop %fs
  popf
  popa
  jmp int15jmp
dt_write:
  push %cx
  push %dx
  push %si
  if_nz %cs:shut_up,999f,b
100: lodsb
  call write_single_char
102:  loop 100b
999:  pop %si
  pop %dx
  pop %cx
  ret

dos_terminate:
# doesn't matter if we knacker a few regs as its goign to die anyway
  xor %dx,%dx
  mov %dx,%es
   mov %al,%es:rc_addr
    dos_int21
# thats it never coems back
dt_tsr_isatty: 
  pusha
 call  tsr_dev_info
   and $0x83,%al
   cmp $0x83,%al
  popa
  ret

write_single_char:
 pusha
  if_nz %cs:shut_up,999f,b
   call tsr_write_char
  if %al,e,$'\r',101f
  if_nz %al,999f
101:
  call do_pause 
999:  popa
  ret
do_pause:
  if_nz no_dbltalk_codes,0f,b
  dos_usleep $500
0:
  ret
tsr_write_char: 
 pusha
  push %ds
  pushf
     movseg %cs,%ds
  mov %al,char_to_write
  dos_get_current_psp
  mov %bx,save_psp
   mov %cs,%bx # bit cludgy but started of as a.com so must be ok
    dos_set_psp
   mov tsr_handle,%bx
     call tsr_dev_info
    if %ax,e,$0x80c0,0f
   if char_to_write,e,$'\r',50f
0: mov $1,%cx
 mov tsr_handle,%bx
    lea char_to_write,%dx
  mov $0x40,%ah
   dos_int21
50:   mov save_psp,%bx
  dos_set_psp
  popf
  pop %ds
 popa
  ret
do_flush: 
 pusha
  push %ds
  pushf
     movseg %cs,%ds
  dos_get_current_psp
  mov %bx,save_psp
   mov %cs,%bx # bit cludgy but started of as a.com so must be ok
    dos_set_psp
 mov $1,%cx
 mov tsr_handle,%bx
  mov $0x68,%ah
   dos_int21
   mov save_psp,%bx
  dos_set_psp
  popf
  pop %ds
 popa
  ret
do_iret_exit:
  popf
  clc
  iret
play_note: 
   pusha
  pushl $500
   if_nz %al,0f
   pushl $1760
  jmp 1f
0: pushl $220
1:  call playnote_ms
 popa
   ret 
tsr_dev_info:
  mov $0x4400,%ax
  dos_int21
  ret
int21jmp_exit:
   popf
  jmp int21jmp
char_to_write: .byte 0
gsym shut_up .byte 0
save_psp: .word 0
gsym tsr_handle .word 3
tsr_fn: .asciz "com1"
.=tsr_fn+0x80
setvoice: .byte 1,0,'o',1,'1','y',1,'1','b',0
