# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

  call pinit
   if_z %ax,0f
    mov argv,%si
  lea fn,%di
  call strcpy_
0:
   if %ax,b,$2,0f
     mov argv+sizeof_int,%si
  call strtoul_
   mov %eax,exec_addr
0:  xopen_file $fn,$0
  mov %ax,%bx
  ext_read %bx,exec_addr,$-1
  dos_close_file
  mov %cs,%eax
  mov %ax,saved_cs
   shl $4,%eax
   or %eax,gdt+gdt_cs+2
   or %eax,gdt+real_ds+2
   or %eax,gdt+real_cs+2
   or %eax,gdt+gdt_ds+2

#set gdt to point to our linear address
   add %eax,gdtr+2

  call enable_a20

  cli
#  disable_nmi
  lidt idtr
  lgdt gdtr
  setbits_cr0 $1
  flush_prefetch
.code32
  flip_cs $gdt_cs
   set_segs $gdt_ds
 mov exec_addr,%ebx
  set_segs $boot_ds
  farcall $boot_cs,%ebx
# ok thats it now try and get back to real
  set_segs $real_ds
   flip_cs $real_cs
.code16
  serial_puts $0x3f8,"we are in 16 bit protected mode"
  mov %cr0,%eax
  and $0xfe,%al
  mov %eax,%cr0
  flip_cs saved_cs
  set_segs %cs
  serial_puts $0x3f8,"ok real mode"
  lidt real_idt
  sti
  terminate 00

.data
# Descriptor tables
#
# NOTE: The intel manual says gdt should be sixteen bytes aligned for
# efficiency reasons.  However, there are machines which are known not
# to boot with misaligned GDTs, so alter this at your peril!  If you alter
# GDT_ENTRY_gdt_CS (in asm/segment.h) remember to leave at least two
# empty GDT entries (one for NULL and one reserved).
#
# NOTE:	On some CPUs, the GDT must be 8 byte aligned.  This is
# true for the Voyager Quad CPU card which will not boot without
# This directive.  16 byte aligment is recommended by intel.
#
	.align 16
idt_table: .space 256*8
	.align	4
	
	.word	0				# alignment byte
idtr: .space 6
gdtr: .word gdt_end-1,gdt,0
desc_start gdt
  .space 8
desc_entry boot_cs,	0xFFFF,0,0x9a00,0xcf
desc_entry boot_ds,	0xFFFF,0,0x9200,0xcf
desc_entry real_cs,	0xFFFF,0,0x9a00,0
desc_entry real_ds,	0xFFFF,0,0x9200,0
desc_entry gdt_cs,	0xFFFF,0,0x9a00,0xcf
desc_entry gdt_ds,	0xFFFF,0,0x9200,0xcf
gdt_end:
exec_addr: .long 0x100000
fn: .asciz "c:\\tmp\\testz.b32"
.=fn+0x80
real_idt: .word 0x3ff,0,0
.bss
saved_cs: .word 0
