# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

_d_secs_track=18
_d_load_seg=0x8000
_d_bits_per_clus=12
_d_fat_length=1
_d_num_fats=1
_d_dir_entries=0x10
_d_total_sectors=_d_heads*_d_secs_track*80
_d_heads=2
_d_reserved=_d_secs_track
_d_fat_offset=_d_reserved
_d_dir_offset=_d_fat_offset+_d_fat_length
_d_dir_length=_d_dir_entries>>4
_d_data_offset=_d_dir_offset+_d_dir_length

d_ignored: jmp 0f
.=d_ignored+3
d_system_id: .asciz "dos"
.=d_system_id+8
d_sector_size: .word 0x200 # bytes per logical sector 
d_sec_per_clus: .byte 0x1 # sectors/cluster 
d_reserved: .word _d_reserved # reserved sectors 
d_fats: .byte 1 # number of FATs 
d_dir_entries: .word _d_dir_entries # root directory entries 
d_sectors: .word _d_total_sectors # number of sectors 
d_media: .byte 0xf8 # media code 
d_fat_length: .word _d_fat_length # sectors/FAT 
d_secs_track: .word _d_secs_track # sectors per track 
d_heads: .word _d_heads # number of heads 
d_hidden: .long 0 # hidden sectors (unused) 
d_total_sect: .long 0 # number of sectors (if sectors == 0) 
# following fields are only used by FAT32 
d_fat32_length: .long 0 # sectors/FAT 
d_flags: .word 0 # bit 8: fat mirroring, low 4: active fat 
d_version: .word 0 # major, minor filesystem version 
d_root_cluster: .long 0 # first cluster in root directory 
d_info_sector: .word 0 # filesystem info sector 
d_backup_boot: .word 0 # backup boot sector 
d_reserved2: .space 12  # Unused 
d_boot_drive: .byte 0
0:
  mov $1,%cx
  zeroreg %dx
   mov $_d_secs_track,%al
  zeroreg %bx
  movseg $_d_load_seg,%es
  read_sector
  ljmp $_d_load_seg,$0x200
.=d_ignored+0x1fe
 .word 0xaa55
  mov %cs,%ax
  mov %ax,%ds
  mov %ax,%es
  playnote_ms $440,$1000
  movl $0xfffff0,fat
  mov $255,%cx
   mov $2,%ax
  mov $3,%bx
0:   put_bit_array $fat,$_d_bits_per_clus,%ax,%ebx
  inc %ax
    inc %bx
  loop 0b
   put_bit_array $fat,$_d_bits_per_clus,%ax,$-1
   call cmosdate
   push %eax
  call bcd2fatdate
  mov %ax,ctime+2
   mov %ax,ctime+4
    call cmostime
   push %eax
   call bcd2fattime
   mov %ax,ctime
 chs_writex1 $0,$_d_fat_offset,$_d_fat_length,%ds,$fat,$3
 chs_writex1 $0,$_d_dir_offset,$_d_dir_length,%ds,$root_dir,$3
 chs_writex1 $0,$_d_data_offset,$256,$0xe0000,,$3
   playnote_ms $440,$3000
   playnote_ms $880,$3000
  bios_read_key
  ljmp $0xf000,$0xfff0
.data
fat: .space _d_sector_sz*_d_fat_length
root_dir:
name:   .ascii "BIOS"
.org name+8,0x20
  .ascii "DAT"
   .byte 0x20,0x18,0
ctime: .word 0,0,0
starthi: .word 0
time: .word 0
date: .word 0
start: .word 2
size: .long 128*0x400
.org root_dir+0x20*_d_dir_entries
