# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
.include "uhci-mac.h"
.include "pci-mac.h"
.include "uhci-mac.h"

xpci_bios_installation_check
  push $some_fn
  call pci16_scan_bus
  terminate 00
some_fn: _enter
   mov %bx,pci_slot
   push $_d_pci_class_dword
  push 2*sizeof_int(_bp)
   call  pci16_read_dword
rol $16,%eax
   if %ax,ne,$0xc03,999f
  rol $16,%eax
  shr $8,%eax
  if %al,e,$0x10,999f
  mov %eax,device_class
  mov 4(_bp),%bx
  call pci_read_ioaddr
  mov %eax,io_addr
  mov %eax,mem_base_regs
  call read_num_ports
  mov %ax,num_ports
  call print_details
999: clc
   leave
  ret
pci_read_ioaddr:
   if_nz device_class,1f,b
  pci16_read_first_ioaddr %bx
  movzwl %ax,%eax
  and $~3,%al
  jmp 999f
1:  pci16_read_dword %bx,$0x10
999:  ret
print_details:
  pushal
   if_nz device_class,1f,b
   call uhci_print_details
   jmp 999f
1: call ehci_print_details
999:  popal
  ret
uhci_print_details:
   fdprint handle,"uhci\n"
  call common_print_details
  call uhci_print_ports
   ret
  ehci_print_details:
   fdprint handle,"ehci\n"
  call common_print_details
   do_fd handle,"mem mapped iobase ==",hex,32,mem_base_regs,$'\n'
  ret
common_print_details:
   fdhex handle,16,pci_slot,$' '
  do_fd handle,"io addr=",hex,32,io_addr,$' '
  do_fd handle,"num ports=",hex,16,num_ports,$'\n'
  ret
read_num_ports:
   if_nz device_class,1f,b
   mov $2,%ax
  jmp 999f
1: 
  extmem_read_dword  mem_base_regs,$0
   movzbl %al,%eax
   add %eax,io_addr
  extmem_read_dword mem_base_regs,$4
  and $0xf,%ax
999:  ret
uhci_print_ports:
  pusha
    mov $_d_usbportsc1,%dx
  zeroreg %bx
   mov num_ports,%cx
0:    fdprint handle,"port "
   fdhex handle,8,%ebx,$'='
    _inw io_addr,%dx
  fdhex handle,16,%edx,$'\n'
  add2 %dx
  inc %bx
  loop 0b
  popa
999: ret
.data
handle: .word 1
.bss
device_class: .long 0
io_addr: .long 0
pci_slot: .word 0
num_ports: .word 0
mem_base_regs: .long 0
