#
#  asmlib, assembler library
#  Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 1, or (at your option)
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#/
.macro parse_args
.data 99
parse_args_continuation: int_t 0
parse_args_bad_opt: .ascii "bad option "
parse_args_help_msg: .ascii "usage:\n"
.text 98
parse_args:
  xpushregs %bx,%cx,%si
  mov argc,%cx
  lea argv,%bx
parse_args_loop_start:
  if_rz %cx,parse_args_term
  mov (%bx),%si
  if_nz parse_args_continuation,parse_args_bloody_ridiculous\@,w
   lodsb
  if %al,ne,$'-',parse_args_non_arg
 push (%si)
  call isspace
  jz parse_args_non_arg
  if_z (%si),parse_args_non_arg,b
parse_args_same_arg: 
lodsb
parse_args_bloody_ridiculous\@:
  pusha
  if_z parse_args_continuation,l_next\@,w
  jmp *parse_args_continuation
l_next\@:
.endm

.macro parse_args_term
.data 99
.byte 0
.text 98
  if %al,e,$'?',parse_args_print_usage
lea parse_args_bad_opt,%si
  jmp l01\@
parse_args_print_usage:
lea parse_args_help_msg,%si
l01\@:  call32 dos_print
  terminate 01
parse_args_next_arg: popa
call check_arg_continuation\@
  jc parse_args_same_arg
call dec_arg
  jmp l2_\@
parse_args_non_arg:  add $near_ptr_sz,%bx 
l2_\@:   dec %cx
   jmp parse_args_loop_start
parse_args_term: mov argc,%ax
 xpopregs %si,%cx,%bx
  ret
check_arg_continuation\@:
  jnc 999f
  if_nz (%si),998f,b
  clc
  jmp 999f
998:   stc
999:
  ret
.endm

.macro getoptitem w,var,msg
.data 99
.ascii "-\w \msg\n"
.text 98
  .byte 0x3c
.ascii "\w"
  jnz l0\@
  incb \var
  stc
  jmp  parse_args_next_arg
l0\@: 
.endm

.macro getoptvalue w,rtn,msg
.data 99
  .ascii "-\w \msg\n"
.text 98
  movw $0,parse_args_continuation
  .byte 0x3c
.ascii "\w"
  jnz l0\@
  if_nz (_si),gv\@,b
 mov $gv\@,%ax
  mov %ax,parse_args_continuation
  clc
  jmp parse_args_next_arg
gv\@:
  call \rtn
  clc
  jmp  parse_args_next_arg
l0\@:
.endm
