#
#  asmlib, assembler library
#  Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 1, or (at your option)
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#/
_d_dos_vec=0x21
pusha_sz=8*sizeof_int
pushal_sz=8*4
fat_dir_entry_sz=0x20
_d_max_path=260
_d_bdev_is_block=0x8000
_d_fat_data_cl_adj=2
_d_dir_entry_sz=0x20

_d_fat_vol=8

.macro mkstruct nm,sep=_,suffix=t,sz=sz
.struct 0
\nm\sep\suffix \nm\sep
\nm\sep\sz=.-\nm\sep\nm
.endm

.macro fat_fs_t p,bdev=bdev_t,cl_io_fn=0
concat_lbl \p,fat_fs:
\bdev \p
fat_boot_sec_t \p
concat_lbl \p,cl_io_fn: int_t \cl_io_fn
.endm

.macro partition_record prfx
concat_lbl \prfx,partition_record:
concat_lbl \prfx,boot_indicator:.byte 0
concat_lbl \prfx,start_head:.byte 0
concat_lbl \prfx,start_cyl_sec:.word 0
concat_lbl \prfx,os: .byte 0
concat_lbl \prfx,end_head:.byte 0
concat_lbl \prfx,end_cyl_sec:.word 0
concat_lbl \prfx,start_offset: .long 0
concat_lbl \prfx,part_len: .long 0
.endm

.macro int13_drive_parms prfx
concat_lbl \prfx,drive_parms:
concat_lbl \prfx,drive: .byte 0
concat_lbl \prfx,drive_type: .byte 0
concat_lbl \prfx,drives: .byte 0
concat_lbl \prfx,heads: .byte 0
concat_lbl \prfx,cyls: .word 0
concat_lbl \prfx,secs: .byte 0
concat_lbl \prfx,parm_table: .long 0
.endm

.macro  chs_readx p
concat_lbl \p,chs_readx:
int13_drive_Parms chs_readx_\p
concat_lbl \p,chs_readx_start: .long 0
concat_lbl \p,chs_readx_num: .byte 0
concat_lbl \p,chs_readx_retries: .byte 0
concat_lbl \p,chs_readx_buf: .long 0
.endm
.macro s_pushal_t p
concat_sym \p,edi .long 0
concat_sym \p,esi .long 0
concat_sym \p,ebp .long 0
concat_sym \p,esp .long 0
concat_sym \p,ebx .long 0
concat_sym \p,edx .long 0
concat_sym \p,ecx .long 0
concat_sym \p,eax .long 0
.endm

.macro s_pusha p
concat_sym \p,di .word 0
concat_sym \p,si .word 0
concat_sym \p,bp .word 0
concat_sym \p,sp .word 0
concat_sym \p,bx .word 0
concat_sym \p,dx .word 0
concat_sym \p,cx .word 0
concat_sym \p,ax .word 0
concat_sym \p,ip .word 0
.endm

.macro s_pushax_t p
concat_lbl \p,s_pushax:
concat_lbl \p,di: int_t 0
concat_lbl \p,si: int_t 0
concat_lbl \p,bp: int_t 0
concat_lbl \p,sp: int_t 0
concat_lbl \p,bx: int_t 0
concat_lbl \p,dx: int_t 0
concat_lbl \p,cx: int_t 0
concat_lbl \p,ax: int_t 0
.endm

.macro s_pushax_segs_t p
concat_lbl \p,s_pushax_segs:
concat_lbl \p,gs: int_t 0
concat_lbl \p,fs: .long 0
concat_lbl \p,es: int_t 0
concat_lbl \p,ds: int_t 0
.endm

.macro fat_boot_sec_t p,si
concat_lbl \p fat_bs:
fbs0_\@:
concat_lbl \p ignored: .space 3 # Boot strap short or near jump 
fbs1_\@:
concat_lbl \p system_id:
.ifnb \si
  .asciz "\si"
.endif
.=fbs1_\@+8
concat_lbl \p sector_size: .word 0 # bytes per logical sector 
concat_lbl \p sec_per_clus: .byte 0# sectors/cluster 
concat_lbl \p reserved: .word 0 # reserved sectors 
concat_lbl \p fats: .byte 0 # number of FATs 
concat_lbl \p dir_entries: .word 0 # root directory entries 
concat_lbl \p sectors: .word 0 # number of sectors 
concat_lbl \p media: .byte 0 # media code 
concat_lbl \p fat_length: .word 0 # sectors/FAT 
concat_lbl \p secs_track: .word 0 # sectors per track 
concat_lbl \p heads: .word 0 # number of heads 
concat_lbl \p hidden: .long 0 # hidden sectors (unused) 
concat_lbl \p total_sect: .long 0 # number of sectors (if sectors == 0) 
# following fields are only used by FAT32 
concat_lbl \p fat32_length: .long 0 # sectors/FAT 
concat_lbl \p flags: .word 0 # bit 8: fat mirroring, low 4: active fat 
concat_lbl \p version: .word 0 # major, minor filesystem version 
concat_lbl \p root_cluster: .long 0 # first cluster in root directory 
concat_lbl \p info_sector: .word 0 # filesystem info sector 
concat_lbl \p backup_boot: .word 0 # backup boot sector 
concat_lbl \p reserved2: .space 12  # Unused 
concat_lbl \p boot_drive: .byte 0
.=fbs0_\@+0x200
.endm

.macro bdev_t p,desc,fl_fn=0,chs_fn=0,lba_fn=0
concat_lbl \p,dev_handle:
concat_lbl \p,dosh: int_t 0
concat_lbl \p,mvol: .byte 0
concat_lbl \p,cur_vol: .long 0
concat_lbl \p,lba: .byte 0 # if lba or not 
concat_lbl \p,part_offset: .long 0 # partition offset
concat_lbl \p,disc_len: .long 0
concat_lbl \p,sec_sz: .word 0
concat_lbl \p,cur_sec: .long 0
concat_lbl \p,num: .word 0 # num secs to read at once
.ifb \desc
concat_lbl \p,desc: .word 0
.else
concat_lbl \p,desc: .word l\@
.data 9999
l\@: .asciz "\desc"
pop_sect
.endif
concat_lbl \p,fl_fn: int_t \fl_fn
concat_lbl \p,chs_fn: int_t \chs_fn
concat_lbl \p,lba_fn: int_t \lba_fn
concat_lbl \p,bytes_xfer: .long 0
concat_lbl \p,secs_xfer: .long 0
.endm

.struct -pushal_sz
s_pushal_t pushal_
.text
.struct -pusha_sz
s_pushax_t pushax_
.text

.macro drive_parms_t p
concat_lbl \p,drive_parms:
concat_lbl \p,media: .long 0
concat_lbl \p,cyls: .long 0
concat_lbl \p,heads: .word 0
concat_lbl \p,secs: .word 0
concat_lbl \p,sec_sz: .word 0
.endm

.macro dir_entry_t p
concat_lbl \p,name: .space 8
concat_lbl \p,ext: .space 3
concat_lbl \p,attr: .byte 0
concat_lbl \p,lcase: .byte 0
concat_lbl \p,ctime_ms: .byte 0
concat_lbl \p,ctime: .word 0
concat_lbl \p,cdate: .word 0
concat_lbl \p,adate: .word 0
concat_lbl \p,starthi: .word 0
concat_lbl \p,time: .word 0
concat_lbl \p,date: .word 0
concat_lbl \p,start: .word 0
concat_lbl \p,size: .long 0
.endm

.macro usbrootdev_t p
concat_lbl \p,usbrootdev:
concat_lbl \p,ioaddr: .long 0
concat_lbl \p,root_type: .byte 0
concat_lbl \p,hd_p: int_t 0
concat_lbl \p,qtd_p: int_t 0
.endm

.macro usbdev_t p,urd=0
concat_lbl \p,usbdev:
concat_lbl \p,urd_p: int_t \urd
concat_lbl \p,dev_addr: .byte 0
.endm

.macro std_dev_descriptor_t p
concat_lbl \p,std_dev_descriptor:
concat_lbl \p,length: .byte 0
concat_lbl \p,type: .byte 0
concat_lbl \p,rev: .word 0
concat_lbl \p,class: .word 0
concat_lbl \p,protocol: .byte 0
concat_lbl \p,max_pkt_sz: .byte 0 # 7
concat_lbl \p,vendor: .word 0
concat_lbl \p,product: .word 0
concat_lbl \p,release: .word 0
concat_lbl \p,imft: .byte 0
concat_lbl \p,iproduct: .byte 0
concat_lbl \p,iserial: .byte 0
concat_lbl \p,num_cfgs: .byte 0
.endm
.struct 0
drive_parms_t drive_parms_
drive_parms_sz:

.struct 0
bdev_t bdev_
bdev_t_sz:

.struct 0
fat_fs_t fat_fs_

.struct 0
dir_entry_t dir_entry_

.struct 0
fat_boot_sec_t fat_boot_sec_

.struct 0
usbrootdev_t usbrootdev_
usbrootdev_sz=.-usbrootdev_usbrootdev
mkstruct s_pushax
mkstruct usbdev
mkstruct std_dev_descriptor
.text
