#
#  asmlib, assembler library
#  Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 1, or (at your option)
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#/
.ifndef __uhci_mac_h
__uhci_mac_h=1

_d_pci_uhci_usb_class=0xc0300

_d_usbcmd=	0
_d_usbcmd_rs=	0x0001	# run/stop 
_d_usbcmd_hcreset=0x0002	# host reset 
_d_usbcmd_greset=	0x0004	# global reset 
_d_usbcmd_egsm=	0x0008	# global suspend mode 
_d_usbcmd_fgr=	0x0010	# force global resume 
_d_usbcmd_swdbg=	0x0020	# sw debug mode 
_d_usbcmd_cf=	0x0040	# config flag (sw only) 
_d_usbcmd_maxp=	0x0080	# max packet (0 = 32, 1 = 64) 
_d_usbsts=	2
_d_usbsts_usbint=	0x0001	# interrupt due to ioc 
_d_usbsts_error=	0x0002	# interrupt due to error 
_d_usbsts_rd=	0x0004	# resume detect 
_d_usbsts_hse=	0x0008	# host system error - basically pci problems 
_d_usbsts_hcpe=	0x0010	# host controller process error - the scripts were buggy 
_d_usbsts_hch=	0x0020	# hc halted 
_d_usbintr=	4
_d_usbintr_timeout=0x0001	# timeout/crc error enable 
_d_usbintr_resume=0x0002	# resume interrupt enable 
_d_usbintr_ioc=	0x0004	# interrupt on complete enable 
_d_usbintr_sp=	0x0008	# short packet interrupt enable 
_d_usbfrnum=6
_d_usbflbaseadd=8
_d_usbsof=	12
_d_usbportsc1=16
_d_usbportsc2=18
_d_usbportsc_ccs=	0x0001	# current connect status ("device present") 
_d_usbportsc_csc=	0x0002	# connect status change 
_d_usbportsc_pe=	0x0004	# port enable 
_d_usbportsc_pec=	0x0008	# port enable change 
_d_usbportsc_dplus=0x0010	# d+ high (line status) 
_d_usbportsc_dminus=0x0020	# d- high (line status) 
_d_usbportsc_rd=	0x0040	# resume detect 
_d_usbportsc_res1=0x0080	# reserved, always 1 
_d_usbportsc_lsda=0x0100	# low speed device attached 
_d_usbportsc_pr=	0x0200	# port reset 
_d_usbportsc_oc=	0x0400	# over current condition 
_d_usbportsc_occ=	0x0800	# over current change r/wc 
_d_usbportsc_susp=0x1000	# suspend 
_d_usbportsc_res2=0x2000	# reserved, write zeroes 
_d_usbportsc_res3=0x4000	# reserved, write zeroes 
_d_usbportsc_res4=0x8000	# reserved, write zeroes 

_d_uhci_maxtd=64
_d_uhci_maxqh=16

.macro uhci_reset_hc io
   push \io
  call32 uhci_reset_hc
.endm


.macro uhci_enable_ports p
  push \p
  call32 uhci_enable_ports
.endm

.macro uhci_reset_sts p
  push \p
  call32 uhci_reset_sts
.endm

.macro uhci_setup_qtd b,pid,p0,sz,dev,endpt,spd
  push \spd
   push \endpt
  push \dev
  push \sz
  push \p0
  push \pid
  push \b
  call32 uhci_setup_qtd
.endm

.macro uhci_wait_status r,qtd,ix,l
  push \l
  push \ix
  push \qtd
   push \r
  call32 uhci_wait_status
.endm


.macro uhci_setup_qh fl,q,ix
   push \ix
   push \q
  push \fl
  call32 uhci_setup_qh
.endm

.macro uhci_do_urb h,u,pg0,sz,e
   push \e
  push \sz
   push \pg0
  push \u
  push \h
   call32 uhci_do_urb
.endm

.macro uhci_init_usbintr r
   push \r
  call32 uhci_init_usbintr
.endm

.macro uhci_config_usbcmd r
   push \r
  call32 uhci_config_usbcmd
.endm

.macro uhci_reset_port r,p
   push \p
   push \r
  call32 uhci_reset_port
.endm

.macro uhci16_init_framelist r,fl
  push \fl
  push \r
  call uhci16_init_framelist
.endm
.endif
