# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
.global prot16_cs
.global prot16_ds
.global prot32_cs
.global prot32_ds
.global flat4gb_ds


   cli
  set_segs %cs
  lea mini_stack,%sp
  sti

  set_intr_gate $3,$idt,$prot32_cs,$dummy_hdlr

   port2uart $0
  mov %ax,uart
  serial_config uart,$12

  set_vector $0x21,%cs,$int21_hdlr
   mov %cs,real_jmp+3
  mov %cs,%eax
   shl $4,%eax
   or %eax,gdt+prot32_cs+2
   or %eax,gdt+prot32_ds+2
   or %eax,gdt+prot16_cs+2
   or %eax,gdt+prot16_ds+2

#set gdt to point to our linear address
   add %eax,gdtr+2
  add %eax,idtr+2

  puts "running ver 0.1"

  call enable_a20
  cli
  disable_nmi
  lidt idtr
  lgdt gdtr
  mov %cr0,%eax
  or $1,%al
  mov %eax,%cr0
 jmp code32_start
gsym prot16_start  serial_puts uart,"we are in 16 bit protected mode"
  mov %cr0,%eax
  and $0xfe,%al
  mov %eax,%cr0
real_jmp:  ljmp $0,$1f
1:   set_segs %cs
 lidt  real_idtr
  enable_nmi
  sti
  puts "we are going back to the bios via int 18"
  int $0x18
int21_hdlr:
  mov %sp,%cs:int_entry_sp
  mov %ss,%cs:int_entry_sp+2
  cli
  mov %cs:real_jmp+3,%ss
   lea int21_stack-2,%sp
   sti
  pusha
   xpushregs %ds,%es,%fs,%gs
  mov %cs,%ax
  mov %ax,%ds
  mov %ax,%es
  lgs int_entry_sp,%bp
  mov %gs:2*sizeof_int(%bp),%ax
  and $0xfe,%al
  mov %ax,%gs:2*sizeof_int(%bp)

  mov save_ax,%ax
  if %ah,e,$2,do_putc
  if %ah,e,$6,do_putc
  if %ah,e,$0x40,do_write
  jmp exit_hdlr
do_putc:
  push %dx
  call write_char
  jmp exit_hdlr 
do_write:
   mov save_dx,%si
  mov save_cx,%cx
 mov save_ds,%fs
  cld
0:  lodsb %fs:(%si)
  push %ax
  call write_char
  loop 0b 
exit_hdlr:  xpopregs %gs,%fs,%es,%ds
  popa
  cli
  lss %cs:int_entry_sp,%sp
  sti
  iret
write_char:  _enter
  pusha
  serial_putc 2*sizeof_int(_bp),uart
  popa
  leave
  ret $sizeof_int
.data
# Descriptor tables
#
# NOTE: The intel manual says gdt should be sixteen bytes aligned for
# efficiency reasons.  However, there are machines which are known not
# to boot with misaligned GDTs, so alter this at your peril!  If you alter
# GDT_ENTRY_gdt_CS (in asm/segment.h) remember to leave at least two
# empty GDT entries (one for NULL and one reserved).
#
# NOTE:	On some CPUs, the GDT must be 8 byte aligned.  This is
# true for the Voyager Quad CPU card which will not boot without
# This directive.  16 byte aligment is recommended by intel.
#
	.align 16
idt_table: .space 256*8
	.align	4
	
	.word	0				# alignment byte
idtr: .word 0x7ff,idt,0
real_idtr: .word 0x3ff,0,0
gdtr: .word gdt_end-1,gdt,0
desc_start gdt
desc_entry flat4gb_cs,	0xFFFF,0,0x9a00,0xcf
desc_entry flat4gb_ds,	0xFFFF,0,0x9200,0xcf
desc_entry prot32_cs,	0xFFFF,0,0x9a00,0xcf
desc_entry prot32_ds,	0xFFFF,0,0x9200,0xcf
desc_entry prot16_cs,	0xFFFF,0,0x9a00,0
desc_entry prot16_ds,	0xFFFF,0,0x9200,0
gdt_end:
.bss
gsym idt .space 8*256
gsym uart .word 0
int_entry_sp: .long 0
  .space 512
save_gs: .word 0
save_fs: .word 0
save_es: .word 0
save_ds: .word 0
  s_pusha save_
int21_stack:  .space 8192
mini_stack: .word 0
