# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

.struct 0x7c00
d_ignored: .space 3
d_system_id:.space 8
d_sector_size: .word 0x200 # bytes per logical sector 
d_sec_per_clus: .byte 0x1 # sectors/cluster 
d_reserved: .word _d_reserved # reserved sectors 
d_fats: .byte 1 # number of FATs 
d_dir_entries: .word _d_dir_entries # root directory entries 
d_sectors: .word _d_total_sectors # number of sectors 
d_media: .byte 0xf8 # media code 
d_fat_length: .word _d_fat_length # sectors/FAT 
d_secs_track: .word _d_secs_track # sectors per track 
d_heads: .word _d_heads # number of heads 
d_hidden: .long 0 # hidden sectors (unused) 
d_total_sect: .long 0 # number of sectors (if sectors == 0) 
# following fields are only used by FAT32 
d_fat32_length: .long 0 # sectors/FAT 
d_flags: .word 0 # bit 8: fat mirroring, low 4: active fat 
d_version: .word 0 # major, minor filesystem version 
d_root_cluster: .long 0 # first cluster in root directory 
d_info_sector: .word 0 # filesystem info sector 
d_backup_boot: .word 0 # backup boot sector 
d_reserved2: .space 12  # Unused 
d_boot_drive: .byte 0
