# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
# todo:
#  addoption to load kernel at other than 0x100000
# use standard init_args stuff

max_read_buf=0x2000
cmd_seg=0x9800
load_initrd=0x3000000
cmdline_buffer=0
cmdline_buffer_sz=512
boot_seg=0x9000
setup_seg=0x9020
boot_param_initrd_start=0x218
boot_param_initrd_size=0x21c
new_cl_ptr=0x28

buffer_sz=0x4000

  call pinit
   call parseargs
   if argc,ge,$2,0f,w
  exit_msg $0,"need setup and kernel file"
0:
  lea stackend,%sp

   call load_setup
   mov argv+2,%dx
  xopen_file %dx,$0
  mov %ax,handle
   ext_read handle,move_to,$-1
    mov handle,%bx
   dos_close_file
  if argc,b,$3,0f,w
  mov argv+4,%dx
   xopen_file %dx,$0
  mov %ax,handle
  ext_read handle,$load_initrd,$-1
  movseg $boot_seg,%fs
   movl $load_initrd,%fs:boot_param_initrd_start
   mov %eax,%fs:boot_param_initrd_size
  mov handle,%bx
  dos_close_file
0:
  if_z have_cmdline,0f,b
  call process_cmdline
0:
  if_z verbose,0f,b
  print "cmdline="
  push %ds
   movseg $cmd_seg,%ds
   zeroreg %si
   call dos_puts
  pop %ds
0:
  movseg $0x40,%fs
     push $0xc
   push %fs:0
  call serial_config
   dos_playnote_ms $440,$1000
  ljmp $setup_seg,$0
  terminate 00

load_setup:
  pusha
  xopen_file argv,$0
  mov %ax,handle_setup
  zeroreg %dx
0:
   mov handle_setup,%bx
  mov $buffer_sz,%cx
  push %ds
  movseg $boot_seg,%ds
  dos_read_handle 
  pop %ds
  exit_if_cf $1,"error fieading setup"
  add %ax,%dx
  if %ax,ae,$buffer_sz,0b
  dos_close_file handle_setup
 popa
  ret
parseargs:
  mov argc,%cx
  lea argv,%bx
0:
  if_or %cx,%cx,z,999f
  mov (%bx),%si
   lodsb
  if %al,ne,$'-',1f
   lodsb
  if %al,ne,$'v',5f
   incb verbose
   jmp 4f
5:
  if %al,ne,$'f',3f
   incb have_cmdline
  call cpy_cfg_fn
4:
  call dec_arg
  jmp 2f
3:
   exit_msg $1,"bad option found only otion   is -f needs first two ars are setup and kernel"
1:
  add $near_ptr_sz,%bx 
2:
   dec %cx
   jmp 0b
999:
  ret

process_cmdline:
  xpushregs %eax,%bx,%cx,%dx,%si,%es
  lea cmdline_fn,%dx
   mov $o_rdonly,%al
   call xfopen
   mov %ax,handle_cmdline

    mov %ax,%bx
  push %ds
  movseg $cmd_seg,%ds
  lea cmdline_buffer,%dx
  mov $cmdline_buffer_sz,%cx
  dos_read_handle
 exit_if_cf $1,"error during read"
  if %ax,be,$cmdline_buffer_sz,0f
  mov $cmdline_buffer_sz,%ax
0:
  mov %ax,%bx
  lea cmdline_buffer,%si
   movb $0,(%bx,%si)
 cld
0:   lodsb
  if_z %al,999f
   if %al,ge,$' ',0b
   movb $' ',-1(%si)
  jmp 0b
999:
  pop %ds
   mov handle_cmdline,%bx
  dos_close_file

  movseg $cmd_seg,%es
  if_or $0,%es:cmdline_buffer,z,0f,b
  zeroreg %edx
 mov %es,%edx
   shl $4,%edx
   add $cmdline_buffer,%edx
   movseg $0,%es
    mov %edx,%es:4*0xf0
   movseg $setup_seg,%es
   mov %edx,%es:new_cl_ptr     
0:
  xpopregs %es,%si,%dx,%cx,%bx,%eax
  ret
cpy_cfg_fn:
  pusha   
  lodsb
  ifisspace 999f
    lea cmdline_fn,%di
2:
  if %al,b,$'.',998f
  stosb
   lodsb
  jmp 2b
998:
   zeroreg %al
  stosb
999:
  popa
  ret
.data
cmdline_fn: .asciz "ldimg.cfg"
.=cmdline_fn+128
handle_cmdline: .word 0
have_cmdline: .byte 0
verbose: .byte 0
move_to: .long 0x100000
.bss
handle: .word 0
handle_setup: .word 0
buffer: .space buffer_sz
bytes_read: .word 0
.space 8192
stackend:
