# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "loadlnx.h"

max_read_buf=0x2000
cmdline_buffer=0
cmdline_buffer_sz=512

  init_args
   arg_item v,verbose,"verbose"
  arg_value f,"kernel parms"
    lea cmdline_fn,%di
  call strcpy_
   incb have_cmdline
  ret
.data
have_cmdline: .byte 0
.bss
cmdline_fn: .asciz "ldimg.cfg"
.=cmdline_fn+128
  arg_value l,"kernel load addr"
   call strtoul_
  mov %eax,move_to
  ret
.data
move_to: .long 0
   init_args_term
   if argc,ge,$1,0f,w
  exit_msg $0,"need kernel file"
0:
  call cfg_ext_mem
    mov %eax,max_mem

  lea stackend,%sp

  xopen_file argv,$0
  mov %ax,handle
   call load_setup
   ext_read handle,move_to,$-1
   dos_close_file handle
  if argc,b,$2,0f,w

  mov max_mem,%ecx
  shr %ecx
  mov %ecx,load_initrd

  mov argv+2,%dx
   xopen_file %dx,$0
  mov %ax,handle
  ext_read handle,load_initrd,$-1
  movseg $boot_seg,%fs
   movl load_initrd,%ecx
  mov %ecx,%fs:boot_param_initrd_start
# eax still has num byes read
   mov %eax,%fs:boot_param_initrd_size
  dos_close_file handle
0:
  if_z have_cmdline,0f,b
  call process_cmdline
0:
  movseg $0x40,%fs
     push $0xc
   push %fs:0
  call serial_config
   dos_playnote_ms $880,$300
    dos_playnote_ms $440,$300
    dos_playnote_ms $880,$300
    cli
   mov $boot_seg,%ax
  mov %ax,%ss
  mov %ax,%ds
  mov %ax,%es
   zeroreg %sp
  sti
  ljmp $setup_seg,$0
  terminate 00

load_setup:
  pusha
  push %fs
  movseg $boot_seg,%fs 
  dos_read handle,%fs,$0,$0x200
  movzbw %fs:boot_setup_secs,%cx
  shl $9,%cx
  dos_read handle,%fs,$0x200,%cx
  if_nz move_to,0f,l
  movl %fs:boot_param_move_to,%eax
   if_rz %eax,0f
  mov %eax,move_to
0:
  pop %fs
 popa
  ret
process_cmdline:
  xpushregs %eax,%bx,%cx,%dx,%si,%es
  lea cmdline_fn,%dx
   mov $o_rdonly,%al
   call xfopen
   mov %ax,handle_cmdline

    mov %ax,%bx
  push %ds
  movseg $cmd_seg,%ds
  lea cmdline_buffer,%dx
  mov $cmdline_buffer_sz,%cx
  dos_read_handle
 exit_if_cf $1,"error during read"
  if %ax,be,$cmdline_buffer_sz,0f
  mov $cmdline_buffer_sz,%ax
0:
  mov %ax,%bx
  lea cmdline_buffer,%si
   movb $0,(%bx,%si)
 cld
0:   lodsb
  if_z %al,999f
   if %al,ge,$' ',0b
   movb $' ',-1(%si)
  jmp 0b
999:
  pop %ds
   mov handle_cmdline,%bx
  dos_close_file

  movseg $cmd_seg,%es
  if_or $0,%es:cmdline_buffer,z,0f,b
  zeroreg %edx
 mov %es,%edx
   shl $4,%edx
   add $cmdline_buffer,%edx
   movseg $0,%es
    mov %edx,%es:4*0xf0
   movseg $setup_seg,%es
   mov %edx,%es:new_cl_ptr     
0:
  xpopregs %es,%si,%dx,%cx,%bx,%eax
  ret
load_initrd: .long 0x3000000
.bss
max_mem: .long 0
handle_cmdline: .word 0
handle: .word 0
bytes_read: .word 0
.space 8192
stackend:
