# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

.struct 0
partition_record pr_
pr_sz=.-pr_partition_record
pop_sect

  init_args
  arg_value o,"output filename"
    lea ofn,%di
  call strcpy_
    ret
.data
ofn: .space 128
  init_args_term

  lea stack_end,%sp
   zeroreg %eax
   mov %cs,%ax
  shl $4,%eax
  add $image_end,%eax
   shr $16,%eax
  inc %eax
  shl $16,%eax
  mov %eax,buf_addr
   shl $12,%eax
  mov %eax,transfer_buf

  pushw $0
    pushw $ofn
  call xcreate_file
   mov %ax,handle

  if_z argc,0f,w
  mov argc,%cx
  lea argv,%bx
1:     mov (%bx),%si
  call strtoul_
  push %ax
  call print_partinfo
  add $sizeof_int,%bx
  loop 1b
  jmp 999f
0:   push drive
  call print_partinfo
999:  mov handle,%bx
  dos_close_file
terminate 00

print_partinfo: enter $0,$0
  xpushregs %bx,%cx

  mov 4(%bp),%dl
  ibm_ext_check
   jnc 0f
    call mbr_read_chs
  jmp 1f
0:   call mbr_read_lba
1:

   mov buf_addr+2,%dx
   shl $12,%dx
  mov %dx,%fs
     mov buf_addr,%si
      lea buf,%di
  mov $_d_sector_sz,%cx
  rep movsb %fs:(%si),%es:(%di)

  fdprint handle,"drive "
   fdhex handle,8,4(%bp),$'\n'
  if_z %ah,0f
  mov %ah,%al
  fdprint handle,"error reading sector status="
  fdhex handle,8,%eax,$'\n'
  terminate 01
0:   mov $4,%cx
   zeroreg %bx
0:  mov %bx,%ax
  shr $4,%ax
  inc %ax
  push %ax
 lea buf+0x1be(%bx),%ax
   push %ax
   call print_pr
  add $pr_sz,%bx
  loop 0b
  xpopregs %cx,%bx
  leave
  ret $2
print_pr: enter $0,$0
  xpushregs %bx,%si
   fdprint handle,"partition "
    fdi2asc handle,w,6(%bp),$'\n'
  mov 4(%bp),%si
   fdprint handle,"boot indicator="
     fdhex handle,8,pr_boot_indicator(%si),$'\n'
   fdprint handle,"os="
     fdhex handle,8,pr_os(%si),$'\n'
  fdprint handle,"start c h s="
  lea pr_start_head(%si),%bx
  call print_chs
  fdprint handle,"end c h s="
  lea pr_end_head(%si),%bx
  call print_chs
   fdprint handle,"start offset="
   fdhex handle,32,pr_start_offset(%si),$'\n'
  fdprint handle,"length="
   fdhex handle,32,pr_part_len(%si)
  fdprint handle," ("
  mov pr_part_len(%si),%eax
   shr $1,%eax
  fdi2asc handle,l,%eax
  fdprint handle,")\n"
  xpopregs %si,%bx
  leave
  ret $4
print_chs:
 xpushregs %dx
   mov 1(%bx),%dx
         xchg %dh,%dl
 shr $6,%dh  
  fdhex handle,10,%edx,$' '
   fdhex handle,8,(%bx),$' '
  fdhex handle,6,1(%bx),$'\n'
  xpopregs %dx
  ret
mbr_read_lba:
  mov 4(%bp),%dl
  lea disc_packet,%si
  extended_read
  ret
mbr_read_chs:
  movseg 4(%bp),chs_readx_d_drive,w
  movl $0,d_chs_readx_start
  movseg buf_addr,d_chs_readx_buf,l
  movb $1,d_chs_readx_num
  movb $3,d_chs_readx_retries
  pushw $d_chs_readx
   call chs_readx
  ret
.data
drive: .byte 0x80
handle: .word 1
chs_readx d_
disc_packet: .word 0x10
num_blocks: .word 1
transfer_buf: .long 0
starting_block: .quad 0
tb64: .quad 0

.bss
buf: .space _d_sector_sz
buf_addr: .long 0
.space 8192
stack_end:
