# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

   cli
  set_segs %cs
  lea mini_stack,%sp
  sti

   port2uart $0
  mov %ax,uart
  serial_config uart,$12
  serial_puts uart,"ok we are here ver 1"
   mov %cs,real_jmp+3
  mov %cs,%eax
   shl $4,%eax
   or %eax,gdt+gdt_cs+2
   or %eax,gdt+real_ds+2
   or %eax,gdt+real_cs+2
   or %eax,gdt+gdt_ds+2

#set gdt to point to our linear address
   add %eax,gdtr+2

  call enable_a20

  cli
  disable_nmi
  lidt idtr
  lgdt gdtr
  mov %cr0,%eax
  or $1,%al
  mov %eax,%cr0
 jmp code32_start
prot16_start:  serial_puts uart,"we are in 16 bit protected mode"
  mov %cr0,%eax
  and $0xfe,%al
  mov %eax,%cr0
real_jmp:  ljmp $0,$1f
1:   set_segs %cs
 lidt  real_idtr
  enable_nmi
  sti
  serial_puts uart,"this is real mode goign back to the bios"
  int $0x18
.code32
code32_start:
  flip_cs $gdt_cs
   set_segs $gdt_ds
   playnote_ms32 $440,$1000
   playnote_ms32 $55,$1000
   playnote_ms32 $440,$1000
  serial_puts32 uart,"ok thisis prot 32 ver 001"
# ok thats it now try and get back to real
  set_segs $real_ds
   flip_cs $real_cs,$prot16_start
.data
# Descriptor tables
#
# NOTE: The intel manual says gdt should be sixteen bytes aligned for
# efficiency reasons.  However, there are machines which are known not
# to boot with misaligned GDTs, so alter this at your peril!  If you alter
# GDT_ENTRY_gdt_CS (in asm/segment.h) remember to leave at least two
# empty GDT entries (one for NULL and one reserved).
#
# NOTE:	On some CPUs, the GDT must be 8 byte aligned.  This is
# true for the Voyager Quad CPU card which will not boot without
# This directive.  16 byte aligment is recommended by intel.
#
	.align 16
idt_table: .space 256*8
	.align	4
	
	.word	0				# alignment byte
idtr: .space 6
real_idtr: .word 0x3ff,0,0
gdtr: .word gdt_end-1,gdt,0
desc_start gdt
desc_entry boot_cs,	0xFFFF,0,0x9a00,0xcf
desc_entry boot_ds,	0xFFFF,0,0x9200,0xcf
desc_entry gdt_cs,	0xFFFF,0,0x9a00,0xcf
desc_entry gdt_ds,	0xFFFF,0,0x9200,0xcf
desc_entry real_cs,	0xFFFF,0,0x9a00,0
desc_entry real_ds,	0xFFFF,0,0x9200,0
gdt_end:
.bss
uart: .word 0
  .space 8192
mini_stack: .word 0
