# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "repro.h"

   init_args
  arg_value o,"output file"
  lea ofn,%di
   call strcpy_
  ret
.data
ofn: .space 0x80
handle: .word 1
   arg_item v,verbose,"verbose"
  arg_value b,"buffer size in secs"
   call strtoul_
  mov %eax,buf_secs
  ret
.data
buf_secs: .long 512
  arg_value s,"skip sectors"
 call strtoul_
    mov %eax,skip_secs
  ret
.data
skip_secs: .long 0
  arg_value n,"max sectors to copy"
 call strtoul_
    mov %eax,num_secs
  ret
.data
num_secs: .long 0
  arg_item r,do_reboot,"reboot instead of returning to dos"
   init_args_term

   lea stack_end,%sp
  if %ax,e,$2,0f
      exit_msg $1,"need input and output file"
0:
  call get_system_time
  mov %eax,start_ticks

  xcreate_file $ofn,$0
  mov %ax,handle
  mov buf_secs,%eax
  shl $_d_sector_shift,%eax
  mov %eax,buf_sz

 zeroreg %eax ,%edx
   mov %cs,%ax
  shl $4,%eax
   add $image_end,%eax
  and $0xf0000,%eax
   add $0x10000,%eax
   mov %eax,buf_addr

push  argv
   call open_input_dev
  mov %ax,ihandle
   push argv+sizeof_int
   call  open_output_dev
  mov %ax,ohandle
  if_z verbose,0f,b
  fdprint handle,"copying "
  fdi2asc handle,l,total_secs_to_copy
  fdprint handle," sectors\n"
0:
  call report_progress
  jc exit_prog
     call copy_sector
  push %eax
  shr $_d_sector_shift,%eax
   add %eax,total_sectors_written
  pop %eax
  if_rnz %eax,0b
exit_prog:
  push ihandle
  call close_dev
   push ohandle
   call close_dev
  if_z verbose,0f,b
  fdprint handle,"total sectors written to outputdev="
  fdi2asc handle,l,total_sectors_written,$'\n'
   fdprint handle,"total secs="
    call get_system_time
  sub start_ticks,%eax
  imul $10,%eax
   mov $182,%ecx
  zeroreg %edx
   div %ecx
    fdi2asc handle,l,%eax,$'\n'
  playnote_ms term_note,$2000
  push finish_msg
  push handle
  call fdprint
  fdputc $'\n',handle
0:
  mov handle,%bx
  dos_close_file
  if_z do_reboot,0f,b
    dos_playnote_ms $55,$1000
  ljmp $0xf000,$0xfff0
0:  mov exit_rc,%al
  dos_exit
open_input_dev: enter $0,$0
  verb_print_str handle,"setting input dev\n"
  mov 4(_bp),%bx
   if (%bx),e,$_d_dev_sig,0f,w
  push 4(_bp)
  call open_input_file
  jmp 999f
0:  push 4(_bp)
call open_input_disc
999:
  leave
  ret $2
open_input_file: enter $0,$0
   push 4(_bp)
  call getfattr
  if %ax,ne,$_d_file_notfound,0f
           print "file "
  mov 4(%bp),%si
  call dos_print
   bail_out $1," not found"       
0:
  if_set $_d_fa_direc,%al,0f
  xopen_file 4(%bp),$o_rdonly
   mov %ax,i_dosh
    lea i_dev_handle,%ax
    jmp 999f
0: bail_out $1,"cant do multi volume yet"
999:  leave
  ret $2
open_input_disc: enter $0,$0
  mov 4(%bp),%si
   call strtoul_
  lea i_dev_handle,%bx
  push %bx
  call set_disc_attrs
  mov skip_secs,%eax
  add %eax,i_part_offset
   mov i_disc_len,%eax
        mov %eax,total_secs_to_copy
  mov num_secs,%eax
  if_rz %eax,0f
    if %eax,a,total_secs_to_copy,0f
  mov %eax,total_secs_to_copy
0:    lea i_dev_handle,%ax
  leave
  ret $2
open_output_dev: enter $0,$0
  verb_print_str handle,"setting output dev\n"
  mov 4(_bp),%bx
   if (%bx),e,$_d_dev_sig,0f,w
  push 4(_bp)
  call open_output_file
  jmp 999f
0:  push 4(_bp)
call open_output_disc
999:
  leave
  ret $2
open_output_file: enter $0,$0
  push $0
   push 4(%bp)
  call xcreate_file
   mov %ax,o_dosh
    lea o_dev_handle,%ax
  leave
  ret $2
open_output_disc: enter $0,$0
  mov 4(%bp),%si
   call strtoul_
  lea o_dev_handle,%bx
  push %bx
  call set_disc_attrs
    lea o_dev_handle,%ax
  leave
  ret $2
close_dev: enter $0,$0
  mov 4(%bp),%bx
  mov _dosh(%bx),%bx
  if_set $0x8000,%bx,999f
  dos_close_file
999:
  leave
  ret $2
copy_sector:
  mov buf_secs,%eax
   if_z num_secs,0f,l
   mov i_secs_xfer,%edx
  if %edx,b,num_secs,1f
    zeroreg %eax
  jmp 999f
1:
   add %eax,%edx
   if %edx,be,num_secs,0f
    mov num_secs,%eax
   sub i_secs_xfer,%eax
0: shl $_d_sector_shift,%eax
   pushl %eax
  pushl buf_addr
  pushw ihandle
   call dev_io
  if_z %eax,999f
  push %eax
  pushl buf_addr
  pushw ohandle
  call dev_io
999:  ret
dev_io:enter $0,$0
  mov 4(%bp),%bx
  if_set $0x8000,_dosh(%bx),do_disc_io,w
   pushl 0xa(%bp)
  pushl 6(%bp)
  push _dosh(%bx)
   call *_fl_fn(%bx)
  pushf
   if %bx,ne,ohandle,0f
  if %eax,e,0xa(%bp),0f
     bail_out $1,"number of bytes written does not match number of bytessent"
0:
  popf
  jnc 999f
   push _desc(%bx)
    push $1
  call fdprint
    fdprint handle," failed @"
     fdi2asc handle,l,0xa(%bp),$'\n'
  bail_out $1 exit_prog
do_disc_io: call disc_io
999:  add %eax,_bytes_xfer(%bx)
  mov _bytes_xfer(%bx),%edx
      shr $_d_sector_shift,%edx
   mov %edx,_secs_xfer(%bx)
  leave
  ret $0xa
disc_io:
  mov _disc_len(%bx),%eax
  sub _cur_sec(%bx),%eax
  jz 999f
  push %eax
   zeroreg %edx
   mov $_d_sector_sz,%ecx
  mov 0xa(%bp),%eax
    div %ecx
  if_z %edx,0f
   inc %eax
0:  pop %edx
  if %eax,b,%edx,0f
    mov %edx,%eax
0:
  mov %ax,_num(%bx)

  mov _cur_sec(%bx),%eax
   add _part_offset(%bx),%eax

  if_nz _lba(%bx),0f,b
  call disc_io_chs
  jmp 999f
0:
  call disc_io_lba
999:
  shl $_d_sector_shift,%eax
  ret
disc_io_lba:
  xpushregs  %cx,%dx,%si

  pushl 6(%bp)
  pushw _num(%bx)
  push %eax
  pushw _dosh(%bx)
  call *_lba_fn(%bx)
   jnc 0f
   call check_lba_error
  jnc 0f
   mov %ax,%dx
   fdprint handle,"failed lba sector read @ "
  fdi2asc handle,l,_cur_sec(%bx),$'\n'
        do_fd handle,"rc=",hex,8,%edx,$'\n'
  bail_out $1
0:
  and $0xffff,%eax
  addl %eax,_cur_sec(%bx)
  xpopregs %si,%dx,%cx
  ret
disc_io_chs:
  xpushregs  %cx,%dx,%si
  pushw $_d_max_retries
  pushl 6(%bp)
  push _num(%bx)
  push %eax
  push _dosh(%bx)
  call *_chs_fn(%bx)
   jnc 0f
   fdprint handle,"failed chs sector "
  push _desc(%bx)
   push $1
  call fdprint
 fdputc $'@',$1
  fdi2asc handle,l,_cur_sec(%bx),$'\n'
  bail_out $1
0:
  and $0xffff,%eax
  addl %eax,_cur_sec(%bx)
  xpopregs %si,%dx,%cx
  ret
set_disc_attrs: push %bp
  mov %sp,%bp
  xpushregs %eax,%bx,%ecx,%edx,%si,%si
  mov 4(%bp),%bp
  movseg buf_secs,_num(%bp),w
  mov %al,d_drive
  mov %ax,_dosh(%bx)
  orw $0x8000,_dosh(%bx)
  mov %al,%dl
  push %bx
  ibm_ext_check
  pop %bx
  jc 0f
  verb_print_str handle,"using  lba\n"
  movb $1,_lba(%bx)
   
  lea lba_dparms,%si
  mov _dosh(%bx),%dl
   ext_drive_parms
  bail_out_if_cf $1,"failed getting lba drive parms"
  mov 0x10(%si),%eax
   mov %eax,_disc_len(%bx)
  jmp 999f
0:  verb_print_str handle,"using chs\n"
pushw $d_drive_parms
 call get_drive_parms
  bail_out_if_cf $1,"cant get drive parms"
  zeroreg %eax,%ecx
  mov d_cyls,%cx
     mov d_heads,%al
  mul %ecx
  zeroreg %ecx
    mov d_secs,%cl
  mul %ecx
  mov %eax,_disc_len(%bp)
999: pop %si
# check to see if partition is requested
#if so override the disc length and start point
  if (%si),ne,$'-',0f,b
    inc %si
  call strtoul_
  or %al,_dosh+1(%bx)
  read_part_offs_len _dosh(%bx),%ax
  mov %eax,_part_offset(%bx)
   mov %edx,_disc_len(%bx)
0:  xpopregs %si,%edx,%ecx,%bx,%eax,%bp
  ret $2
.if 0
log_read:
  fdprint handle,"r="
  jmp do_log
log_write:
  fdprint handle,"w="
do_log: enter $0,$0
  mov 4(%bp),%ax
  xchg %ah,%al
  fdhex handle,16,%eax,$','
  fdhex handle,32,_secs_xfer(%bx),$','
  fdi2asc handle,w,0xa(%bp),$'\n'
  zeroreg %eax
  mov 0xa(%bp),%ax
 clc
  leave
   ret $0xc
.endif
check_lba_error:
 push %edx
  mov %eax,%edx
  shr $16,%edx
   if %dl,ne,$0x10,998f
  mov %ax,%dx
  do_fd handle,"bad crc @ ",hex,32,_cur_sec(%bx),$' '
  do_fd handle,"xfered=",i2asc,w,%dx,$'\n'
  mov %dx,%ax
  if_nz %ax,0f
    inc %ax
0: clc
  jmp 999f
998:  stc
999:  pop %edx
  ret
verb_print: enter $0,$0
  if_z verbose,999f,b
  pusha
  push 3*sizeof_int(_bp)
   push 2*sizeof_int(_bp)
  call fdprint
  popa
999:
 leave
   ret $2*sizeof_int
report_progress:
 pushal
  ifn_kbhit 999f
  call getchx
   if %ax,ne,$0x1b,1f
  lea  abort_msg,%ax
  mov %ax,finish_msg
 movl $55,term_note
     stc
  jmp 999f
1:  fdi2asc handle,l,total_sectors_written,$'\n'
  playnote_ms $440,$50
998:  clc
999:
  popal
  ret
.data
total_sectors_written: .long 0
ihandle: .word 0
ohandle: .word 0
bdev_t i_,"read",readx,chs_readx1,lba_read
bdev_t o_,"write",writex,chs_writex1,lba_write
lba_dparms:.word _d_dparms_sig
.=lba_dparms+_d_dparms_sig
exit_rc: .byte 0
finish_msg: .word msg_ok
msg_ok: .asciz "terminated normally"
abort_msg: .asciz "abort by keypress"
term_note:  .long 1760
.bss
total_secs_to_copy: .long 0
buf_sz: .long 0
int13_drive_parms d_
buf_addr: .long 0
start_ticks: .long 0
  .space 8192
stack_end:
