# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "sndf.h"

_d_ack_timeout=93

  init_args
  arg_value d,"divisor 12=9600 1=115200"
   call strtoul_
  mov %ax,baud_divisor
  ret
.data
baud_divisor: .byte 1
  arg_value o,"output filename"
  lea ofn,%di
  call strcpy_
  ret
.data
ofn: .asciz "sndf.log"
.=ofn+0x80
 arg_value p,"port 1..."
   call strtoul_
  mov %ax,port
  ret
.data
port: .word 1
  init_args_term
0:
  xcreate_file $ofn,$0
  mov %ax,handle

  if_nz argc,0f
      fdprint handle,"no args need at least one prog\n"
  jmp exit_prog1
0:

  decw port
  port2uart port
  mov %ax,uart

   serial_config uart,baud_divisor
   mov argc,%cx
  lea argv,%bx
0:
  pushw (%bx)
call processfile
   printreg cx $'\n'
  add $sizeof_int,%bx
    loop 0b
0:
  serial_putc $-1,uart
  bios_check_keystroke
  jnz exit_prog
  mov uart,%dx
   add $_d_lsr,%dx
  in (%dx),%al
    if_unset $1,%al,0b
    mov uart,%dx
   in (%dx),%al
exit_prog:
  dos_playnote_ms  $1760,$100
  serial_config uart,$12
exit_prog1:  mov handle,%bx
  dos_close_file
  terminate 00

processfile:  enter $0,$0
  xpushregs %bx,%cx

  call do_sig
  fdprint handle,"got sig ok sending file info\n"

  pushw 4(%bp)
    call xgetfsize
   mov %eax,fsize
  zeroreg %edx
    mov $_d_block_sz,%ecx
   div %ecx
  if_z %edx 0f
   inc %eax
0:
  mov %ax,num_blocks

   pushw 4(%bp)
   pushw uart
   call send_fn

  pushw  $fsize
   pushw uart
   call send_flen
  wait_ack uart,$'f'

  fdprint handle,"sending data\n"
   xopen_file 4(%bp),$o_rdonly
  mov %ax,dfd
  mov num_blocks,%ecx
  movl $0,byte_count
0:
  call load_buf

 push %ax
  call send_with_resends
  and $0xffff,%eax
  add %eax,byte_count
  loop 0b
   mov dfd,%bx
   dos_close_file
  xpopregs %cx,%bx

  leave
  ret $2
do_sig:
  xpushregs %ax,%cx,%dx,%di
  mov $0,%cx
0:  bios_check_keystroke
  jnz exit_prog
  mov uart,%dx
  add $_d_lsr,%dx
  in (%dx),%al
  if_set $1,%al,500f
dos_playnote_ms $440,$500
  serial_putc $1,uart
  pushl $500
  call dos_usleep
  loop 0b
  dos_playnote_ms $55,$2000
  fdprint handle,"sent max number of sig bytes giving up"
  jmp exit_prog
500: pushw uart
  call print_status
  mov uart,%dx
  in (%dx),%al
  fdprint handle,"received sig confirmation char="
  lea output_line,%di
  hex2asc $8,%eax
    movw $'\n',(%di)
  pushw $output_line
  pushw handle
  call fdprint
  push  uart
   pushw $_d_block_sz
  call serial_putc
  push  uart
   pushw $_d_block_sz>>8
  call serial_putc
  wait_ack uart,$'b'
  xpopregs %di,%dx,%cx,%ax
  ret
load_buf:
  xpushregs %bx,%cx,%dx
  mov dfd,%bx
  mov $_d_block_sz,%cx
  lea buf,%dx
  dos_read_handle
  exit_if_cf $1,"error reading file"
  xpopregs %dx,%cx,%bx
  ret
send_with_resends: enter $0,$0
  xpushregs %ax
0:  pushw 4(%bp)
  call send_buf
  fdprint handle,"waiting ack\n"
  push uart
   call _wait_ack
  if %al,ne,$'r',999f
  fdprint handle,"doing resend at "
  fdhex handle,32,byte_count,$'\n'
  jmp exit_prog
999: 
xpopregs %ax
  leave
  ret $2
send_buf: enter $0,$0
  xpushregs %ax,%cx,%dx,%si
  lea buf,%si
  push 4(%bp)
  push %si
  call crc8
  pushw uart
  push %ax
  call serial_putc
  
  mov 4(%bp),%cx
0:
   lodsb
  pushw uart
  push %ax
  call serial_putc
  loop 0b
  xpopregs %si,%dx,%cx,%ax
  leave
  ret $2
_wait_ack: enter $0,$0
  xpushregs %ecx,%dx
  call bios_tix
  mov %eax,%ecx
  add $_d_ack_timeout,%ecx
0:   bios_check_keystroke
  jz 1f
  fdprint handle,"key pressed waiting for ack"
  jmp exit_prog
1:
mov 4(%bp),%dx
  add  $_d_lsr,%dx
  in (%dx),%al
  if_set $1,%al,50f
  call bios_tix
  if %eax,b,%ecx,0b
  fdprint handle,"time out waiting for ack"
  jmp exit_prog
50: mov 4(%bp),%dx
  in (%dx),%al
999: 
xpopregs %dx,%ecx
  leave
  ret $2
wait_ack: enter $0,$0
  push %ax
0:  push 4(%bp)
 call _wait_ack
  if %al,e,6(%bp),999f
  fdprint handle,"invalid ack char received "
  fdhex handle,8,%eax
  fdprint handle," it should be "
  fdhex handle,8,6(%bp)
  jmp 0b
pop %ax
999:  leave
  ret $4
serial_write:
  enter $0,$0
  xpushregs %ax,%cx,%si
  mov 8(%bp),%cx
  lea 6(%bp),%si
0:   lodsb
  pushw 4(%bp)
  push %ax
  call serial_putc
  loop 0b
  xpopregs %si,%cx,%ax
  leave
   ret $6
print_status:
  enter $0,$0
  mov 4(%bp),%dx
 add $_d_lsr,%dx
  in (%dx),%al
  mov 4(%bp),%dx
 add $_d_msr,%dx
  in (%dx),%al
  leave
  ret $2
send_fn: enter $0,$0
  xpushregs %ax,%si
    mov 6(%bp),%si
0: lodsb
   if_z %al,1f
   pushw 4(%bp)
    push %ax
  call serial_putc
  jmp 0b
1:  push 4(%bp)
  pushw $'\n'
   call serial_putc
  xpopregs %si,%ax
  leave
  ret $4
send_flen: enter $0,$0
  xpushregs %ax,%cx,%si
  mov $4,%cx
    mov 6(%bp),%si
0: lodsb
   pushw 4(%bp)
    push %ax
  call serial_putc
  loop 0b
1:
  xpopregs %si,%cx,%ax
  leave
  ret $4
xgetfsize:
  pushw 4(%bp)
  call getfsize
 jnc 0f
   fdprint handle,"error opening file: "
  fdprint handle,,4(%bp)
   jmp exit_prog
0:
  ret $2
.data
fsize: .long 0
num_blocks: .long 0
.bss
uart: .word 0
buf: .space _d_block_sz
handle: .word 0
.bss
byte_count: .long 0
output_line: .space 80
dfd: .word 0
