# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
.include "sect.h"
.global _start

max_errors=100
numsecs=1
sector_size=0x200

_start:
  process_cmdline fn,drive,start_sector,num_sectors,"write file to"
  lea fn,%dx
  xor %al,%al # read only
  dos_open_file
  jnc open_ok 
  print "Unable to open "
  lea fn,%si
  call dos_puts
  terminate 01
open_ok:
  mov %ax,handle
  get_drive_parms_die_on_error drive
  store_drive_parms max_cyls,sectors_per_track,max_heads,sectors_per_cyl
  mov start_sector,%bx
  mov num_sectors,%cx
get_next_record:
  push %bx
  push %cx
  mov handle,%bx 
mov $sector_size,%cx
  lea bootsect,%dx
  dos_read_handle
  jnc 100f
  print "Error reading file"
  lea fn,%si
  call dos_puts
  terminate 01
100:
  pop %cx
  pop %bx
  or %ax,%ax
  jz all_done
100:  call process_sector
  jnc write_ok
  call test_error_max
   jmp 100b
write_ok:  inc %bx
  loop get_next_record
all_done:  mov handle,%bx
  dos_close_file
  terminate 00

process_sector:
  push %bx
  push %cx
setup_int13_parms drive,%bx,$numsecs,  sectors_per_cyl,sectors_per_track
  movseg_offs %cs,$bootsect,%es,%bx
  write_sector

  pop %cx
   pop %bx
  ret

test_error_max:
  push %ax
   mov error_count,%ax
  inc %ax
  mov %ax,error_count
   cmp $max_errors,%ax
 jb try_again
    puts "Error max reached writing sectos giving up"
    terminate 01
try_again: pop %ax
  ret

drive: .byte 0
start_sector: .word 1
num_sectors: .word 1
max_cyls: .word 0
sectors_per_cyl: .word 0
sectors_per_track: .byte 0
max_heads: .byte 0
error_count: .word 0
handle: .word 0
fn: .fill 128
bootsect: .fill 512
